



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>广播与P2P通道（下） -- 方案实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">广播与P2P通道（下） -- 方案实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-02 08:25:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在<strong><a href="http://www.cnblogs.com/zhuweisky/archive/2013/04/25/3012448.html" rel="external nofollow noreferrer">广播与P2P通道（上） -- 问题与方案</a></strong>&nbsp;一文中，我们已经找到了最优的模型，即将广播与P2P通道相结合的方案，这样能使服务器的带宽消耗降到最低，最大节省服务器的宽带支出。当然，如果从零开始实现这种方案无疑是非常艰巨的，但基于<strong><a href="http://www.oraycn.com/ESFramework.aspx" rel="external nofollow noreferrer">ESFramework</a></strong>提供的通信功能和P2P功能来做，就不再那么遥不可及了。</p>
<p><strong>1.P2P通道状态</strong></p>
<p>根据上文模型3的讨论，要实现该模型，每个客户端需要知道自己与哪些用户创建了P2P通道，服务器也要知道每个客户端已建立的P2P通道的状态。</p>
<p>使用<strong><a href="http://www.oraycn.com/ESFramework.aspx" rel="external nofollow noreferrer">ESFramework</a></strong>，在客户端已经可以通过IRapidPassiveEngine.P2PController接口知道当前客户端与哪些其它客户端成功建立了P2P通道，并且可以通过P2PController接口发起与新的客户端建立新的P2P通道的尝试。但在服务端，对于每个客户端建立了哪些P2P通道，服务端是一无所知的。所以，基于ESFramework实现模型3的第一件事情，就是客户端要实时把自己的P2P状态变化报告给服务端，而服务端也要管理每个客户端的P2P通道状态。（注意。下面的所有实现，需要引用ESFramework.dll、ESPlus.dll、ESBasic.dll）</p>
<p><strong>（1）P2PChannelManager</strong></p>
<p>我们在服务端设计P2PChannelManager类来管理每个在线客户端已成功创建的所有P2P通道。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public class P2PChannelManager<br />
    {<br />
        //key 表示P2P通道的起始点用户ID，value 表示P2P通道的目的点用户列表。（单向，因为某些P2P通道就是单向的）<br />
        private SortedArray&lt;string, SortedArray&lt;string&gt;&gt; channels = new SortedArray&lt;string, SortedArray&lt;string&gt;&gt;();

        public void Initialize(IUserManager userManager)<br />
        {<br />
            userManager.SomeOneDisconnected += new ESBasic.CbGeneric&lt;UserData, ESFramework.Server.DisconnectedType&gt;(userManager_SomeOneDisconnected);<br />
        }

        void userManager_SomeOneDisconnected(UserData user, ESFramework.Server.DisconnectedType obj2)<br />
        {<br />
            this.channels.RemoveByKey(user.UserID);<br />
        }

        public void Register(string startUserID, string destUserID)<br />
        {<br />
            if (!this.channels.ContainsKey(startUserID))<br />
            {<br />
                this.channels.Add(startUserID, new SortedArray&lt;string&gt;());<br />
            }

            this.channels[startUserID].Add(destUserID);<br />
        }

        public void Unregister(string startUserID, string destUserID)<br />
        {<br />
            if (this.channels.ContainsKey(startUserID))<br />
            {<br />
                this.channels[startUserID].Remove(destUserID);<br />
            }<br />
        }

        public bool IsP2PChannelExist(string startUserID, string destUserID)<br />
        {<br />
            if (!this.channels.ContainsKey(startUserID))<br />
            {<br />
                return false;<br />
            }

            return this.channels[startUserID].Contains(destUserID);<br />
        }

     }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>P2PChannelManager提供了注册P2P通道、注销P2P通道、以及查询P2P通道是否存在的方法。其内部使用类似字典的SortedArray来管理每个用户的已经成功建立的P2P通道（即与哪些其它用户打通了P2P）。另外，P2PChannelManager预定了IUserManager的SomeOneDisconnected事件，这样，当某个用户掉线时，就可以清除其所有的P2P状态。因为，在ESFramework中，当客户端与服务器的TCP连接断开时，客户端会自动关闭所有的P2P通道。</p>
<p><strong>（2）客户端实时报告自己的P2P状态变化给服务端</strong></p>
<p>当客户端每次成功创建一个P2P通道、或者已有P2P通道中断时，客户端要发消息告诉服务端。这样，我们就需要定义这个消息的类型：</p>
<div>
<pre class="prettyprint linenums">    public static class MyInfoTypes<br />
    {<br />
        public const int P2PChannelOpen = 1;<br />
        public const int P2PChannelClose = 2;<br />
    }</pre>
</div>
<p>再定义消息协议：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public class P2PChannelReportContract<br />
    {<br />
        public P2PChannelReportContract() { }<br />
        public P2PChannelReportContract(string dest)<br />
        {<br />
            this.destUserID = dest;<br />
        }

        #region DestUserID<br />
        private string destUserID;<br />
        public string DestUserID<br />
        {<br />
            get { return destUserID; }<br />
            set { destUserID = value; }<br />
        }<br />
        #endregion<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>定好了消息类型和contract类，我们在客户端预定P2P通道的状态变化，并报告给服务端：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">　  public void Initialize(IRapidPassiveEngine rapidPassiveEngine)<br />
    {<br />
        rapidPassiveEngine.P2PController.P2PChannelOpened += new CbGeneric&lt;P2PChannelState&gt;(P2PController_P2PChannelOpened);<br />
        rapidPassiveEngine.P2PController.P2PChannelClosed += new CbGeneric&lt;P2PChannelState&gt;(P2PController_P2PChannelClosed);<br />
    }<br />
<br />    void P2PController_P2PChannelClosed(P2PChannelState state)<br />
    {<br />
        this.P2PChannelReport(false, state.DestUserID);<br />
    }

    void P2PController_P2PChannelOpened(P2PChannelState state)<br />
    {<br />
        this.P2PChannelReport(true, state.DestUserID);<br />
    }

    private void P2PChannelReport(bool open, string destUserID)<br />
    {<br />
        P2PChannelReportContract contract = new P2PChannelReportContract(destUserID);<br />
        int messageType = open ? MyInfoTypes.P2PChannelOpen : MyInfoTypes.P2PChannelClose;<br />
        this.rapidPassiveEngine.CustomizeOutter.Send(messageType, CompactPropertySerializer.Default.Serialize(contract));<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>在服务端，我们需要处理这两种类型的消息（实现ICustomizeHandler接口的HandleInformation方法）：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    private P2PChannelManager p2PChannelManager = new P2PChannelManager();<br />
　  public void HandleInformation(string sourceUserID, int informationType, byte[] information)<br />
    {<br />
        if (informationType == MyInfoTypes.P2PChannelOpen)<br />
        {<br />
            P2PChannelReportContract contract = CompactPropertySerializer.Default.Deserialize&lt;P2PChannelReportContract&gt;(information, 0);<br />
            this.p2PChannelManager.Register(sourceUserID, contract.DestUserID);<br />
            return ;<br />
        }

        if (informationType == MyInfoTypes.P2PChannelClose)<br />
        {<br />
            P2PChannelReportContract contract = CompactPropertySerializer.Default.Deserialize&lt;P2PChannelReportContract&gt;(information, 0);<br />
            this.p2PChannelManager.Unregister(sourceUserID, contract.DestUserID);<br />
            return ;<br />
        }<br />    ｝</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>这样，服务端就实时地知道每个客户端的P2P状态了。</p>
<p><strong>2.与广播结合</strong></p>
<p>同样的，我们首先为广播消息定义一个消息类型：</p>
<div>
<pre class="prettyprint linenums">    public static class MyInfoTypes<br />
    {<br />
        public const int P2PChannelOpen = 1;<br />
        public const int P2PChannelClose = 2;<br />
        public const int Broadcast = 3; //广播消息<br />
    }</pre>
</div>
<p>再定义对应的协议类：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public class BroadcastContract<br />
    {<br />
        #region Ctor<br />
        public BroadcastContract() { }<br />
        public BroadcastContract(string _broadcasterID, string _groupID, int infoType ,byte[] info )<br />
        {<br />
            this.broadcasterID = _broadcasterID;<br />
            this.groupID = _groupID;<br />
            this.content = info;<br />
            this.informationType = infoType;<br />
            this.actionTypeOnChannelIsBusy = action;<br />
        }<br />
        #endregion

        #region BroadcasterID<br />
        private string broadcasterID = null;<br />
        /// &lt;summary&gt;<br />
        /// 发出广播的用户ID。<br />
        /// &lt;/summary&gt;<br />
        public string BroadcasterID<br />
        {<br />
            get { return broadcasterID; }<br />
            set { broadcasterID = value; }<br />
        }<br />
        #endregion

        #region GroupID<br />
        private string groupID = "";<br />
        /// &lt;summary&gt;<br />
        /// 接收广播的组ID<br />
        /// &lt;/summary&gt;<br />
        public string GroupID<br />
        {<br />
            get { return groupID; }<br />
            set { groupID = value; }<br />
        }<br />
        #endregion

        #region InformationType<br />
        private int informationType = 0;<br />
        /// &lt;summary&gt;<br />
        /// 广播信息的类型。<br />
        /// &lt;/summary&gt;<br />
        public int InformationType<br />
        {<br />
            get { return informationType; }<br />
            set { informationType = value; }<br />
        }<br />
        #endregion

        #region Content<br />
        private byte[] content;<br />
        public byte[] Content<br />
        {<br />
            get { return content; }<br />
            set { content = value; }<br />
        }<br />
        #endregion

  }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>（1）在客户端发送广播消息</strong></p>
<p>在客户端，我们根据与组内成员的P2P通道的状态，来判断发送的方案，就像依据上文提到的，可细分为三种情况：</p>
<p>a.当某个客户端发现自己和组内的所有其它成员都建立了P2P通道时，那么，它就不用把广播消息发送给服务器了。</p>
<p>b.如果客户端与组内的所有其它成员的P2P通道都没有建立成功，那么，它只需要将广播消息发送给服务器。</p>
<p>c.如果客户端与部分组内的成员建立了P2P通道，那么，它不仅需要将广播消息发送给服务器，还需要将该广播消息经过每个P2P通道发送一次。</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">    public void Broadcast(string currentUserID, string groupID, int broadcastType, byte[] broadcastContent)<br />
    {<br />
        BroadcastContract contract = new BroadcastContract(currentUserID, groupID, broadcastType, broadcastContent);<br />
        byte[] info = CompactPropertySerializer.Default.Serialize(contract);<br />
        List&lt;string&gt; members = this.groupManager.GetGroupMembers(groupID);<br />
        if (members == null)<br />
        {<br />
            return;<br />
        }<br />
        bool allP2P = true;<br />
        foreach (string memberID in members)<br />
        {<br />
            if (memberID == this.currentUserID)<br />
            {<br />
                continue;<br />
            }

            if (rapidPassiveEngine.P2PController.IsP2PChannelExist(memberID))<br />
            {<br />
                rapidPassiveEngine.CustomizeOutter.SendByP2PChannel(memberID, MyInfoTypes.Broadcast, info, ActionTypeOnNoP2PChannel.Discard, true, ActionTypeOnChannelIsBusy.Continue);<br />
            }<br />
            else<br />
            {<br />
                allP2P = false;<br />
            }<br />
        }

        if (!allP2P) //只要有一个组成员没有成功建立P2P，就要发给服务端。<br />
        {<br />
            this.rapidPassiveEngine.CustomizeOutter.Send(null, this.groupInfoTypes.Broadcast, info, true, action);<br />
        }<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>&nbsp;（2）服务端转发广播</strong></p>
<p>当服务器收到一个广播消息时，首先，查看目标组中的用户，然后，根据广播消息的发送者的P2P通道状态，来综合决定该广播消息需要转发给哪些客户端。我们只需在上面的HandleInformation方法中增加代码就可以了：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">　  if (informationType == MyInfoTypes.Broadcast)<br />
    {<br />
        BroadcastContract contract = CompactPropertySerializer.Default.Deserialize&lt;BroadcastContract&gt;(information, 0);<br />
        string groupID = contract.GroupID;

        List&lt;string&gt; members = this.groupManager.GetGroupMembers(groupID);<br />
        if (members != null)<br />
        {<br />
            foreach (string memberID in members)<br />
            {<br />
                bool useP2PChannel = this.p2PChannelManager.IsP2PChannelExist(sourceUserID, memberID);<br />
                if (memberID != sourceUserID &amp;&amp; !useP2PChannel)<br />
                {<br />
                    this.customizeController.Send(memberID, MyInfoTypes.Broadcast, information, true, ActionTypeOnChannelIsBusy.Continue);<br />
                }<br />
            }<br />
        }<br />
        return;<br />
    }</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p><strong>（3）客户端处理接收到的广播消息</strong></p>
<p>客户端也只要实现ICustomizeHandler接口的HandleInformation方法，就可以处理来自P2P通道或者转发自服务端的广播消息了（即处理MyInfoTypes.Broadcast类型的消息），这里就不赘述了。</p>
<p>实际上，本文的实现还可以进一步优化，特别是在高频的广播消息时（如前文举的视频会议的例子），这种优化效果是很明显的。那就是，比如，我们在客户端可以将组内的成员分成两类管理起来，一类是P2P已经打通的，一类是没有通的，并根据实际的P2P状态变化而调整。这样，客户端每次发送广播消息时，就不用遍历自己与每个组员的P2P通道的状态，这可以节省不少的cpu时间。同理，服务端也可以如此处理。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j2ekw8.html">第三个Sprint冲刺第八天</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q70rzx8.html">JavaScript中数组的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jxpllq.html">Join的表顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gk3j08.html">iPad开发--QQ空间&comma;处理横竖屏布局&comma;实现子控件中的代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjlxvq.html">UVa 400</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7gv1q.html">概述Log4j简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd1olm8.html">li添加浮动时不能完全包裹的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wglxoq.html">一个例子说明如何在DataSnap中使用FireDAC</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2jjz9.html">六月计划&num;1A&lpar;6&period;1-6&period;8&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yw0nr8.html">VMware vSphere 服务器虚拟化之二十 桌面虚拟化之准备虚拟桌面模版</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zmw7e9.html">idea 15破解方法记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6wl59.html">CJOJ 免费航班</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjeory8.html">java10 - 泛型与枚举</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pey6v8.html">FB商务管理平台&lpar;Business Manager&rpar; （2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj3zmk8.html">Linux-day1-pdf课件</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gl5yvq.html">windows下更换pip源</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1ryd9.html">noip第7课资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vmo5zq.html">css修改select下拉列表的默认样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vr676q.html">PHP实现JS的无符号右移&lpar;&amp;gt&semi;&amp;gt&semi;&amp;gt&semi;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7egz1x9.html">Apache Doris通过supervisor进行进程管理</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jkme38.html">php  dday1&period;&period;&period;  web服务器的搭建  数据库的安装&period;&period;&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpjojvq.html">python reduce使用实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kv4m49.html">&lbrack;HMLY&rsqb;4&period;CocoaPods详解----制作</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1v6jxq.html">&lbrack;SOJ&rsqb; 畅通工程续</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zp6y39.html">js便利关联数组 及数组定义方式 分类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjlxwk8.html">解决larave-dompdf中文字体显示问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kv2d69.html">&commat;Autowired与 &commat;Resource</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p3gnv8.html">jQuery 设置select默认选中问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mejvdrq.html">URL中文参数乱码的一个解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jknzx8.html">C&num;打包时设置图标ico错误</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
